=== modified file 'tests/upstream_import.py'
--- tests/upstream_import.py	2009-04-10 21:09:41 +0000
+++ tests/upstream_import.py	2010-02-09 09:11:13 +0000
@@ -154,6 +154,18 @@
             return ZipFileWrapper(fileobj, 'w')
         return self.make_archive(maker)
 
+    def make_tar_with_bzrdir(self):
+        result = StringIO()
+        tar_file = tarfile.open('tar-with-bzrdir.tar', 'w', result)
+        os.mkdir('toplevel-dir')
+        tar_file.add('toplevel-dir')
+        os.mkdir('toplevel-dir/.bzr')
+        tar_file.add('toplevel-dir/.bzr')
+        tar_file.close()
+        rmtree('toplevel-dir')
+        result.seek(0)
+        return result
+
     def test_top_path(self):
         self.assertEqual(top_path('ab/b/c'), 'ab')
         self.assertEqual(top_path('etc'), 'etc')
@@ -223,5 +235,11 @@
         import_tar(tree, tar_file)
         self.assertTrue(tree.path2id('README') is not None)
 
+    def test_no_crash_with_bzrdir(self):
+        tar_file = self.make_tar_with_bzrdir()
+        tree = BzrDir.create_standalone_workingtree('tree')
+        import_tar(tree, tar_file)
+        # So long as it did not crash, that should be ok
+
 def test_suite():
     return makeSuite(TestImport)

=== modified file 'upstream_import.py'
--- upstream_import.py	2009-04-10 21:09:41 +0000
+++ upstream_import.py	2009-11-13 00:43:08 +0000
@@ -163,6 +163,10 @@
             yield member.name
 
 
+def should_ignore(relative_path):
+    return top_path(relative_path) == '.bzr'
+
+
 def import_tar(tree, tar_input):
     """Replace the contents of a working directory with tarfile contents.
     The tarfile may be a gzipped stream.  File ids will be updated.
@@ -203,6 +207,8 @@
             relative_path = relative_path.rstrip('/')
         if relative_path == '':
             continue
+        if should_ignore(relative_path):
+            continue
         add_implied_parents(implied_parents, relative_path)
         trans_id = tt.trans_id_tree_path(relative_path)
         added.add(relative_path.rstrip('/'))

